#pragma once
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include "pandaLog.h"

using namespace std;

class PANDALOG_API CivCsvReader
{
public:
	explicit CivCsvReader(const char*);

	void readOnLoad();
	void readByColumn(int column, vector<string>& vec);

	void readByRow(int row, vector<string>& vec);

	// ȡ
	int getRows();

	// ȡ
	int getColumns();

	vector<string> getHeaders();
private:
	ifstream _csvInput;
	vector<vector<string>> mVecVec;
	vector<string> mHeaders;
};
