#pragma once
#include<string>
#include<map>
#include<vector>
#include "pandaLog.h"

// ַת
#define TransUTFCoding(name) CivCommonUtils::string_To_UTF8(name)
#define UTFTransCoding(name) CivCommonUtils::UTF8_To_string(name)
// ǰϵͳ
#define CurrentDate CivCommonUtils::currentDate()

// ȡǰϵͳʱ
#define CurrentTime CivCommonUtils::currentTime()

#define CurrentHour CivCommonUtils::currentHour()

class PANDALOG_API CivCommonUtils
{
public:

    // std:stringתUTF8
    static std::string string_To_UTF8(const std::string& str);

    /**
     * UTF8תstd:string
     * ת̣Ƚutf8ת˫ֽUnicode룬
     * ͨWideCharToMultiByteַתΪֽڡ
     */
    static std::string UTF8_To_string(const std::string& str);

    static void genSeqNo(const std::string& prefix, int size, std::vector<std::string>& res);

    /**
    *@brief ȡϵͳǰʱ
    */
    static std::string currentTime();

    /**
     *@brief ȡϵͳǰ
    */
    static std::string currentDate();

    static int currentHour();

    static std::string lstrip(char str[],char c);

    static std::string  getExePath(void);

    ///**
    //*@brief jsonַΪ
    //*/
    //static std::map<std::string, std::string>  parseJson(std::string jsonStr);
};
